GLView

- Main Page
- Related Pages
- Data Structures
- Files
- Examples

Enumerations | Functions
GLView

## Enumerations
enum | Elm_GLView_Mode { , ELM_GLVIEW_ALPHA = (1<<1), ELM_GLVIEW_DEPTH = (1<<2), ELM_GLVIEW_STENCIL = (1<<3), ELM_GLVIEW_DIRECT = (1<<4), ELM_GLVIEW_CLIENT_SIDE_ROTATION = (1<<5), ELM_GLVIEW_DEPTH_8 = ELM_GLVIEW_DEPTH | (1 << 6), ELM_GLVIEW_DEPTH_16 = ELM_GLVIEW_DEPTH | (2 << 6), ELM_GLVIEW_DEPTH_24 = ELM_GLVIEW_DEPTH | (3 << 6), ELM_GLVIEW_DEPTH_32 = ELM_GLVIEW_DEPTH | (4 << 6), ELM_GLVIEW_STENCIL_1 = ELM_GLVIEW_STENCIL | (1 << 9), ELM_GLVIEW_STENCIL_2 = ELM_GLVIEW_STENCIL | (2 << 9), ELM_GLVIEW_STENCIL_4 = ELM_GLVIEW_STENCIL | (3 << 9), ELM_GLVIEW_STENCIL_8 = ELM_GLVIEW_STENCIL | (4 << 9), ELM_GLVIEW_STENCIL_16 = ELM_GLVIEW_STENCIL | (5 << 9), ELM_GLVIEW_MULTISAMPLE_LOW = (1 << 12), ELM_GLVIEW_MULTISAMPLE_MED = (2 << 12), ELM_GLVIEW_MULTISAMPLE_HIGH = (3 << 12) }
| Selects the target surface properties. More...
enum | Elm_GLView_Resize_Policy { ELM_GLVIEW_RESIZE_POLICY_RECREATE = 1, ELM_GLVIEW_RESIZE_POLICY_SCALE = 2 }
| Defines a policy for the glview resizing. More...
enum | Elm_GLView_Render_Policy { ELM_GLVIEW_RENDER_POLICY_ON_DEMAND = 1, ELM_GLVIEW_RENDER_POLICY_ALWAYS = 2 }
| Defines a policy for gl rendering. More...

## Functions
EOAPI void | elm_obj_glview_size_set (int w, int h)
| Sets the size of the glview. More...
EOAPI void | elm_obj_glview_size_get (int *w, int *h)
| Get the size of the glview. More...
EOAPI Eina_Bool | elm_obj_glview_resize_policy_set (Elm_GLView_Resize_Policy policy)
| Set the resize policy for the glview object. More...
EOAPI void | elm_obj_glview_changed_set (void)
| Notifies that there has been changes in the GLView.
EOAPI void | elm_obj_glview_resize_func_set (Elm_GLView_Func_Cb func)
| Set the resize function that gets called when resize happens. More...
EOAPI void | elm_obj_glview_del_func_set (Elm_GLView_Func_Cb func)
| Set the render function that runs in the main loop. More...
EOAPI void | elm_obj_glview_init_func_set (Elm_GLView_Func_Cb func)
| Set the init function that runs once in the main loop. More...
EOAPI Eina_Bool | elm_obj_glview_render_policy_set (Elm_GLView_Render_Policy policy)
| Set the render policy for the glview object. More...
EOAPI Eina_Bool | elm_obj_glview_mode_set (Elm_GLView_Mode mode)
| Set the mode of the GLView. More...
EOAPI void | elm_obj_glview_render_func_set (Elm_GLView_Func_Cb func)
| Set the render function that runs in the main loop. More...
EOAPI Evas_GL_API * | elm_obj_glview_gl_api_get (void)
| Get the gl api struct for gl rendering. More...
EOAPI Evas_GL * | elm_obj_glview_evas_gl_get (void)
| Get the internal Evas GL attached to this view. More...
EOAPI int | elm_obj_glview_rotation_get (void)
| Get the current GL view's rotation when using direct rendering. More...
void | elm_glview_size_set (Elm_Glview *obj, int w, int h)
| Sets the size of the glview. More...
void | elm_glview_size_get (const Elm_Glview *obj, int *w, int *h)
| Get the size of the glview. More...
Eina_Bool | elm_glview_resize_policy_set (Elm_Glview *obj, Elm_GLView_Resize_Policy policy)
| Set the resize policy for the glview object. More...
void | elm_glview_changed_set (Elm_Glview *obj)
| Notifies that there has been changes in the GLView.
void | elm_glview_resize_func_set (Elm_Glview *obj, Elm_GLView_Func_Cb func)
| Set the resize function that gets called when resize happens. More...
void | elm_glview_del_func_set (Elm_Glview *obj, Elm_GLView_Func_Cb func)
| Set the render function that runs in the main loop. More...
void | elm_glview_init_func_set (Elm_Glview *obj, Elm_GLView_Func_Cb func)
| Set the init function that runs once in the main loop. More...
Eina_Bool | elm_glview_render_policy_set (Elm_Glview *obj, Elm_GLView_Render_Policy policy)
| Set the render policy for the glview object. More...
Eina_Bool | elm_glview_mode_set (Elm_Glview *obj, Elm_GLView_Mode mode)
| Set the mode of the GLView. More...
void | elm_glview_render_func_set (Elm_Glview *obj, Elm_GLView_Func_Cb func)
| Set the render function that runs in the main loop. More...
Evas_GL_API * | elm_glview_gl_api_get (const Elm_Glview *obj)
| Get the gl api struct for gl rendering. More...
Evas_GL * | elm_glview_evas_gl_get (const Elm_Glview *obj)
| Get the internal Evas GL attached to this view. More...
int | elm_glview_rotation_get (const Elm_Glview *obj)
| Get the current GL view's rotation when using direct rendering. More...
Evas_Object * | elm_glview_add (Evas_Object *parent)
| Add a new glview to the parent. More...

## Detailed Description

A GLView widget allows for simple GL rendering in elementary environment. GLView hides all the complicated evas_gl details so that the user only has to deal with registering a few callback functions for rendering to a surface using OpenGL APIs.

This widget emits the following signals, besides the ones sent from GLView:

- `"focused"` - when glview has received focus.
- `"unfocused"` - when glview has lost focus.
- `"language,changed"` - the program's language changed

Below is an illustrative example of how to use GLView and and OpenGL to render in elementary environment. glview_example_01_page

## Enumeration Type Documentation

enum Elm_GLView_Mode

Selects the target surface properties.

An OR combination of `Elm_GLView_Mode` values should be passed to elm_glview_mode_set when setting up a GL widget. These flags will specify the properties of the rendering target surface; in particular, the mode can request the surface to support alpha, depth and stencil buffers.

Note
  `ELM_GLVIEW_CLIENT_SIDE_ROTATION` is a special value that indicates to EFL that the application will handle the view rotation when the device is rotated. This is needed only when the application requests direct rendering. Please refer to Evas_GL for more information about direct rendering.

See also
  elm_glview_mode_set
  elm_opengl_page

Enumerator
ELM_GLVIEW_ALPHA | Alpha channel enabled rendering mode.
ELM_GLVIEW_DEPTH | Depth buffer enabled rendering mode (24 bits by default)
ELM_GLVIEW_STENCIL | Stencil buffer enabled rendering mode (8 bits by default)
ELM_GLVIEW_DIRECT | Request direct rendering, unless there must be a fallback.
ELM_GLVIEW_CLIENT_SIDE_ROTATION | Client will handle GL view rotation if direct rendering is enabled.
ELM_GLVIEW_DEPTH_8 | Request min. 8 bits for the depth buffer
ELM_GLVIEW_DEPTH_16 | Request min. 16 bits for the depth buffer
ELM_GLVIEW_DEPTH_24 | Request min. 24 bits for the depth buffer (default)
ELM_GLVIEW_DEPTH_32 | Request min. 32 bits for the depth buffer
ELM_GLVIEW_STENCIL_1 | Request min. 1 bits for the stencil buffer
ELM_GLVIEW_STENCIL_2 | Request min. 2 bits for the stencil buffer
ELM_GLVIEW_STENCIL_4 | Request min. 4 bits for the stencil buffer
ELM_GLVIEW_STENCIL_8 | Request min. 8 bits for the stencil buffer (default)
ELM_GLVIEW_STENCIL_16 | Request min. 16 bits for the stencil buffer
ELM_GLVIEW_MULTISAMPLE_LOW | MSAA with minimum number of samples.
ELM_GLVIEW_MULTISAMPLE_MED | MSAA with half the number of maximum samples.
ELM_GLVIEW_MULTISAMPLE_HIGH | MSAA with maximum number of samples.

enum Elm_GLView_Render_Policy

Defines a policy for gl rendering.

The rendering policy tells glview where to run the gl rendering code. ELM_GLVIEW_RENDER_POLICY_ON_DEMAND tells glview to call the rendering calls on demand, which means that the rendering code gets called only when it is visible.

Note
  Default is ELM_GLVIEW_RENDER_POLICY_ON_DEMAND

Enumerator
ELM_GLVIEW_RENDER_POLICY_ON_DEMAND | Render only when there is a need for redrawing.
ELM_GLVIEW_RENDER_POLICY_ALWAYS | Render always even when it is not visible.

enum Elm_GLView_Resize_Policy

Defines a policy for the glview resizing.

The resizing policy tells glview what to do with the underlying surface when resize happens. ELM_GLVIEW_RESIZE_POLICY_RECREATE will destroy the current surface and recreate the surface to the new size. ELM_GLVIEW_RESIZE_POLICY_SCALE will instead keep the current surface but only display the result at the desired size scaled.

Note
  Default is ELM_GLVIEW_RESIZE_POLICY_RECREATE

Enumerator
ELM_GLVIEW_RESIZE_POLICY_RECREATE | Resize the internal surface along with the image.
ELM_GLVIEW_RESIZE_POLICY_SCALE | Only resize the internal image and not the surface.

## Function Documentation

Evas_Object* elm_glview_add | ( | Evas_Object * | parent | ) |

Add a new glview to the parent.

Parameters

  parent | The parent object

Returns
  The new object or NULL if it cannot be created

void elm_glview_del_func_set | ( | Elm_Glview * | obj,
|  | Elm_GLView_Func_Cb | func
| ) |  |

Set the render function that runs in the main loop.

The registered del function gets called when GLView object is deleted. This function allows glview to hide all the rendering context/surface details and have the user just call GL calls that they desire when delete happens.

Parameters

  [in] | func | The delete function to be registered.

References elm_obj_glview_del_func_set().

Evas_GL* elm_glview_evas_gl_get | ( | const Elm_Glview * | obj | ) |

Get the internal Evas GL attached to this view.

Note
  The returned Evas_GL must not be destroyed as it is still owned by the view. But this pointer can be used then to call all the evas_gl_ functions.

Since
  1.12

Returns
  The Evas_GL used by this GLView.

References elm_obj_glview_evas_gl_get().

Evas_GL_API* elm_glview_gl_api_get | ( | const Elm_Glview * | obj | ) |

Get the gl api struct for gl rendering.

Returns
  The api object or NULL if it cannot be created

References elm_obj_glview_gl_api_get().

void elm_glview_init_func_set | ( | Elm_Glview * | obj,
|  | Elm_GLView_Func_Cb | func
| ) |  |

Set the init function that runs once in the main loop.

The registered init function gets called once during the render loop. This function allows glview to hide all the rendering context/surface details and have the user just call GL calls that they desire for initialization GL calls.

Parameters

  [in] | func | The init function to be registered.

References elm_obj_glview_init_func_set().

Eina_Bool elm_glview_mode_set | ( | Elm_Glview * | obj,
|  | Elm_GLView_Mode | mode
| ) |  |

Set the mode of the GLView.

Supports alpha, depth, stencil.

Returns
  True if set properly.

Direct is a hint for the elm_glview to render directly to the window given that the right conditions are met. Otherwise it falls back to rendering to an offscreen buffer before it gets composited to the window.

Parameters

  [in] | mode | The mode Options OR'ed enabling Alpha, Depth, Stencil, Direct.

References elm_obj_glview_mode_set().

void elm_glview_render_func_set | ( | Elm_Glview * | obj,
|  | Elm_GLView_Func_Cb | func
| ) |  |

Set the render function that runs in the main loop.

The render function gets called in the main loop but whether it runs depends on the rendering policy and whether elm_glview_changed_set() gets called.

Parameters

  [in] | func | The render function to be registered.

References elm_obj_glview_render_func_set().

Eina_Bool elm_glview_render_policy_set | ( | Elm_Glview * | obj,
|  | Elm_GLView_Render_Policy | policy
| ) |  |

Set the render policy for the glview object.

By default, the render policy is set to ELM_GLVIEW_RENDER_POLICY_ON_DEMAND. This policy is set such that during the render loop, glview is only redrawn if it needs to be redrawn. (i.e. when it is visible) If the policy is set to #ELM_GLVIEWW_RENDER_POLICY_ALWAYS, it redraws regardless of whether it is visible or needs redrawing.

Parameters

  [in] | policy | The render policy.

References elm_obj_glview_render_policy_set().

void elm_glview_resize_func_set | ( | Elm_Glview * | obj,
|  | Elm_GLView_Func_Cb | func
| ) |  |

Set the resize function that gets called when resize happens.

The resize function gets called during the render loop. This function allows glview to hide all the rendering context/surface details and have the user just call GL calls that they desire when resize happens.

Parameters

  [in] | func | The resize function to be registered.

References elm_obj_glview_resize_func_set().

Eina_Bool elm_glview_resize_policy_set | ( | Elm_Glview * | obj,
|  | Elm_GLView_Resize_Policy | policy
| ) |  |

Set the resize policy for the glview object.

By default, the resize policy is set to ELM_GLVIEW_RESIZE_POLICY_RECREATE. When resize is called it destroys the previous surface and recreates the newly specified size. If the policy is set to ELM_GLVIEW_RESIZE_POLICY_SCALE, however, glview only scales the image object and not the underlying GL Surface.

Parameters

  [in] | policy | The scaling policy.

References elm_obj_glview_resize_policy_set().

int elm_glview_rotation_get | ( | const Elm_Glview * | obj | ) |

Get the current GL view's rotation when using direct rendering.

Returns
  A window rotation in degrees (0, 90, 180 or 270)

Note
  This rotation can be different from the device orientation. This rotation value must be used in case of direct rendering and should be taken into account by the application when setting the internal rotation matrix for the view.

See also
  ELM_GLVIEW_CLIENT_SIDE_ROTATION

Since
  1.12

References elm_obj_glview_rotation_get().

void elm_glview_size_get | ( | const Elm_Glview * | obj,
|  | int * | w,
|  | int * | h
| ) |  |

Get the size of the glview.

Note that this function returns the actual image size of the glview. This means that when the scale policy is set to ELM_GLVIEW_RESIZE_POLICY_SCALE, it'll return the non-scaled size.

Parameters

  [out] | w | width of the glview object
  [out] | h | height of the glview object

References elm_obj_glview_size_get().

void elm_glview_size_set | ( | Elm_Glview * | obj,
|  | int | w,
|  | int | h
| ) |  |

Sets the size of the glview.

Parameters

  [in] | w | width of the glview object
  [in] | h | height of the glview object

References elm_obj_glview_size_set().

EOAPI void elm_obj_glview_del_func_set | ( | Elm_GLView_Func_Cb | func | ) |

Set the render function that runs in the main loop.

The registered del function gets called when GLView object is deleted. This function allows glview to hide all the rendering context/surface details and have the user just call GL calls that they desire when delete happens.

Parameters

  [in] | func | The delete function to be registered.

Referenced by elm_glview_del_func_set().

EOAPI Evas_GL* elm_obj_glview_evas_gl_get | ( | void |  | ) |

Get the internal Evas GL attached to this view.

Note
  The returned Evas_GL must not be destroyed as it is still owned by the view. But this pointer can be used then to call all the evas_gl_ functions.

Since
  1.12

Returns
  The Evas_GL used by this GLView.

Referenced by elm_glview_evas_gl_get().

EOAPI Evas_GL_API* elm_obj_glview_gl_api_get | ( | void |  | ) |

Get the gl api struct for gl rendering.

Returns
  The api object or NULL if it cannot be created

Referenced by elm_glview_gl_api_get().

EOAPI void elm_obj_glview_init_func_set | ( | Elm_GLView_Func_Cb | func | ) |

Set the init function that runs once in the main loop.

The registered init function gets called once during the render loop. This function allows glview to hide all the rendering context/surface details and have the user just call GL calls that they desire for initialization GL calls.

Parameters

  [in] | func | The init function to be registered.

Referenced by elm_glview_init_func_set().

EOAPI Eina_Bool elm_obj_glview_mode_set | ( | Elm_GLView_Mode | mode | ) |

Set the mode of the GLView.

Supports alpha, depth, stencil.

Returns
  True if set properly.

Direct is a hint for the elm_glview to render directly to the window given that the right conditions are met. Otherwise it falls back to rendering to an offscreen buffer before it gets composited to the window.

Parameters

  [in] | mode | The mode Options OR'ed enabling Alpha, Depth, Stencil, Direct.

Referenced by elm_glview_mode_set().

EOAPI void elm_obj_glview_render_func_set | ( | Elm_GLView_Func_Cb | func | ) |

Set the render function that runs in the main loop.

The render function gets called in the main loop but whether it runs depends on the rendering policy and whether elm_glview_changed_set() gets called.

Parameters

  [in] | func | The render function to be registered.

Referenced by elm_glview_render_func_set().

EOAPI Eina_Bool elm_obj_glview_render_policy_set | ( | Elm_GLView_Render_Policy | policy | ) |

Set the render policy for the glview object.

By default, the render policy is set to ELM_GLVIEW_RENDER_POLICY_ON_DEMAND. This policy is set such that during the render loop, glview is only redrawn if it needs to be redrawn. (i.e. when it is visible) If the policy is set to #ELM_GLVIEWW_RENDER_POLICY_ALWAYS, it redraws regardless of whether it is visible or needs redrawing.

Parameters

  [in] | policy | The render policy.

Referenced by elm_glview_render_policy_set().

EOAPI void elm_obj_glview_resize_func_set | ( | Elm_GLView_Func_Cb | func | ) |

Set the resize function that gets called when resize happens.

The resize function gets called during the render loop. This function allows glview to hide all the rendering context/surface details and have the user just call GL calls that they desire when resize happens.

Parameters

  [in] | func | The resize function to be registered.

Referenced by elm_glview_resize_func_set().

EOAPI Eina_Bool elm_obj_glview_resize_policy_set | ( | Elm_GLView_Resize_Policy | policy | ) |

Set the resize policy for the glview object.

By default, the resize policy is set to ELM_GLVIEW_RESIZE_POLICY_RECREATE. When resize is called it destroys the previous surface and recreates the newly specified size. If the policy is set to ELM_GLVIEW_RESIZE_POLICY_SCALE, however, glview only scales the image object and not the underlying GL Surface.

Parameters

  [in] | policy | The scaling policy.

Referenced by elm_glview_resize_policy_set().

EOAPI int elm_obj_glview_rotation_get | ( | void |  | ) |

Get the current GL view's rotation when using direct rendering.

Returns
  A window rotation in degrees (0, 90, 180 or 270)

Note
  This rotation can be different from the device orientation. This rotation value must be used in case of direct rendering and should be taken into account by the application when setting the internal rotation matrix for the view.

See also
  ELM_GLVIEW_CLIENT_SIDE_ROTATION

Since
  1.12

Referenced by elm_glview_rotation_get().

EOAPI void elm_obj_glview_size_get | ( | int * | w,
|  | int * | h
| ) |  |

Get the size of the glview.

Note that this function returns the actual image size of the glview. This means that when the scale policy is set to ELM_GLVIEW_RESIZE_POLICY_SCALE, it'll return the non-scaled size.

Parameters

  [out] | w | width of the glview object
  [out] | h | height of the glview object

Referenced by elm_glview_size_get().

EOAPI void elm_obj_glview_size_set | ( | int | w,
|  | int | h
| ) |  |

Sets the size of the glview.

Parameters

  [in] | w | width of the glview object
  [in] | h | height of the glview object

Referenced by elm_glview_size_set().